
{*******************************************************}
{                                                       }
{       Turbo Pascal Version 7.0                        }
{       Turbo Vision Unit                               }
{                                                       }
{       Copyright (c) 1992 Borland International        }
{                                                       }
{*******************************************************}

{ Drivers unit has been rewritten completely.           }
{ OS/2 system error handler is used, so SysErrorFunc,   }
{ SystemError,SysColorAttr,SysMonoAttr and SaveInt09    }
{ are not available. MouseIntFlag variable is not       }
{ supported also.                                       }
{ New services are introduced to support keystroke      }
{ macros.                                               }

{pragma off(Warn);}
{pragma off(check_range);}

unit Drivers;

{ $X+,I-,S-,P-,Cdecl-}

interface

uses Objects,{$ifndef __OS2__} Crt, {$endif} use32;

{ ******** EVENT MANAGER ******** }

const

{ Event codes }

  evMouseDown = $0001;
  evMouseUp   = $0002;
  evMouseMove = $0004;
  evMouseAuto = $0008;
  evKeyDown   = $0010;
  evCommand   = $0100;
  evBroadcast = $0200;

{ Event masks }

  evNothing   = $0000;
  evMouse     = $000F;
  evKeyboard  = $0010;
  evMessage   = $FF00;

{ Extended key codes }

  kbEsc       = $011B;  kbAltSpace  = $0200;  kbCtrlIns   = $0400;
  kbShiftIns  = $0500;  kbCtrlDel   = $0600;  kbShiftDel  = $0700;
  kbBack      = $0E08;  kbCtrlBack  = $0E7F;  kbShiftTab  = $0F00;
  kbTab       = $0F09;  kbAltQ      = $1000;  kbAltW      = $1100;
  kbAltE      = $1200;  kbAltR      = $1300;  kbAltT      = $1400;
  kbAltY      = $1500;  kbAltU      = $1600;  kbAltI      = $1700;
  kbAltO      = $1800;  kbAltP      = $1900;  kbCtrlEnter = $1C0A;
  kbEnter     = $1C0D;  kbAltA      = $1E00;  kbAltS      = $1F00;
  kbAltD      = $2000;  kbAltF      = $2100;  kbAltG      = $2200;
  kbAltH      = $2300;  kbAltJ      = $2400;  kbAltK      = $2500;
  kbAltL      = $2600;  kbAltZ      = $2C00;  kbAltX      = $2D00;
  kbAltC      = $2E00;  kbAltV      = $2F00;  kbAltB      = $3000;
  kbAltN      = $3100;  kbAltM      = $3200;  kbF1        = $3B00;
  kbF2        = $3C00;  kbF3        = $3D00;  kbF4        = $3E00;
  kbF5        = $3F00;  kbF6        = $4000;  kbF7        = $4100;
  kbF8        = $4200;  kbF9        = $4300;  kbF10       = $4400;
  kbHome      = $4700;  kbUp        = $4800;  kbPgUp      = $4900;
  kbGrayMinus = $4A2D;  kbLeft      = $4B00;  kbRight     = $4D00;
  kbGrayPlus  = $4E2B;  kbEnd       = $4F00;  kbDown      = $5000;
  kbPgDn      = $5100;  kbIns       = $5200;  kbDel       = $5300;
  kbShiftF1   = $5400;  kbShiftF2   = $5500;  kbShiftF3   = $5600;
  kbShiftF4   = $5700;  kbShiftF5   = $5800;  kbShiftF6   = $5900;
  kbShiftF7   = $5A00;  kbShiftF8   = $5B00;  kbShiftF9   = $5C00;
  kbShiftF10  = $5D00;  kbCtrlF1    = $5E00;  kbCtrlF2    = $5F00;
  kbCtrlF3    = $6000;  kbCtrlF4    = $6100;  kbCtrlF5    = $6200;
  kbCtrlF6    = $6300;  kbCtrlF7    = $6400;  kbCtrlF8    = $6500;
  kbCtrlF9    = $6600;  kbCtrlF10   = $6700;  kbAltF1     = $6800;
  kbAltF2     = $6900;  kbAltF3     = $6A00;  kbAltF4     = $6B00;
  kbAltF5     = $6C00;  kbAltF6     = $6D00;  kbAltF7     = $6E00;
  kbAltF8     = $6F00;  kbAltF9     = $7000;  kbAltF10    = $7100;
  kbCtrlPrtSc = $7200;  kbCtrlLeft  = $7300;  kbCtrlRight = $7400;
  kbCtrlEnd   = $7500;  kbCtrlPgDn  = $7600;  kbCtrlHome  = $7700;
  kbAlt1      = $7800;  kbAlt2      = $7900;  kbAlt3      = $7A00;
  kbAlt4      = $7B00;  kbAlt5      = $7C00;  kbAlt6      = $7D00;
  kbAlt7      = $7E00;  kbAlt8      = $7F00;  kbAlt9      = $8000;
  kbAlt0      = $8100;  kbAltMinus  = $8200;  kbAltEqual  = $8300;
  kbCtrlPgUp  = $8400;  kbAltBack   = $0800;  kbNoKey     = $0000;

{ Additional keyboard codes that Borland forgot to define }

 kbCtrlA      = $1E01;  kbCtrlB     = $3002;  kbCtrlC     = $2E03;
 kbCtrlD      = $2004;  kbCtrlE     = $1205;  kbCtrlF     = $2106;
 kbCtrlG      = $2207;  kbCtrlH     = $2308;  kbCtrlI     = $1709;
 kbCtrlJ      = $240A;  kbCtrlK     = $250B;  kbCtrlL     = $260C;
 kbCtrlM      = $320D;  kbCtrlN     = $310E;  kbCtrlO     = $180F;
 kbCtrlP      = $1910;  kbCtrlQ     = $1011;  kbCtrlR     = $1312;
 kbCtrlS      = $1F13;  kbCtrlT     = $1414;  kbCtrlU     = $1615;
 kbCtrlV      = $2F16;  kbCtrlW     = $1117;  kbCtrlX     = $2D18;
 kbCtrlY      = $1519;  kbCtrlZ     = $2C1A;

{ 101-key AT keyboard }

 kbAltTab     = $A500; kbAltDel     = $A300;  kbAltIns    = $A200;
 kbAltPgDn    = $A100; kbAltDown    = $A000;  kbAltEnd    = $9F00;
 kbAltRight   = $9D00; kbAltLeft    = $9B00;  kbAltPgUp   = $9900;
 kbAltUp      = $9800; kbAltHome    = $9700;  kbCtrlTab   = $9400;
 kbCtrlGreyPlus=$9000; kbCtrlCenter = $8F00;  kbCtrlMinus = $8E00;
 kbCtrlUp     = $8D00; kbAltF12     = $8C00;  kbAltF11    = $8B00;
 kbCtrlF12    = $8A00; kbCtrlF11    = $8900;  kbShiftF12  = $8800;
 kbShiftF11   = $8700; kbF12        = $8600;  kbF11       = $8500;
 kbAltGrayPlus= $4E00; kbCenter     = $4C00;  kbAltGreyAst= $3700;
 kbAltSlash   = $3500; kbAltPeriod  = $3400;  kbAltComma  = $3300;
 kbAltBackSlash=$2B00; kbAltOpQuote = $2900;  kbAltQuote  = $2800;
 kbAltSemicolon=$2700; kbAltRgtBrack= $1B00;  kbAltLftBrack=$1A00;
 kbAltEsc     = $0100; kbCtrlDown   = $9100;

{ Special keys }

kbAltShiftBack = $0900;

{ Keyboard state and shift masks }

  kbRightShift  = $0001;
  kbLeftShift   = $0002;
  kbCtrlShift   = $0004;
  kbAltShift    = $0008;
  kbScrollState = $0010;
  kbNumState    = $0020;
  kbCapsState   = $0040;
  kbInsState    = $0080;

{ Mouse button state masks }

  mbLeftButton  = $01;
  mbRightButton = $02;

type
{$ifndef __OS2__}
  VioModeInfo = record          { Record for VioSetMode / VioGetMode          }
    cb:         Word;           { Size of this structure                      }
    fbType:     Byte;           { 8-bit mask identifying the mode             }
    Color:      Byte;           { Colors available. Power of 2 (1=2,2=4,4=16) }
    Col:        Word;           { Number of text character columns            }
    Row:        Word;           { Number of text character rows               }
    HRes:       Word;           { Display width in pixels                     }
    VRes:       Word;           { Display height in pixels                    }
    fmt_ID:     Byte;           { Format of the attributes                    }
    Attrib:     Byte;           { Number of attributes in the attribfmt field }
    Buf_Addr:   Pointer;        { Address of the phisical display buffer      }
    Buf_Length: Longint;        { Length of the phisical display buffer       }
    Full_Length: Longint;       { Size of the buffer to save entire phis. buf.}
    Partial_Length: Longint;    { Size of the buffer to save part of the phis. buf. overwritten by VioPopup }
    Ext_Data_Addr: Pointer;     { Address of an extended-mode structure       }
  end;

  VioCursorInfo = record        { Record for VioSetCurType / VioGetCurType    }
    yStart:     Word;           { Cursor start scan line (0-based)            }
    cEnd:       Word;           { Cursor end scan line                        }
    cx:         Word;           { Cursor width (0=default width)              }
    Attr:       Word;           { Cursor color attribute (-1 = hidden)        }
  end;

  MouEventInfo = record         { Record for MouReadEventQue                  }
    fs:         Word;           { Event bits                                  }
    Time:       Longint;        { Event timestamp (unique number of milliseconds)}
    Row:        Word;           { Pointer current row position                }
    Col:        Word;           { Pointer current column position             }
  end;

  MouQueInfo = record           { Record for MouGetNumQueEl                   }
    cEvents:    Word;           { Number of elements in event queue           }
    cMaxEvents: Word;           { Maximum queue size in elements              }
  end;
{$endif }

{ Event record }

  PEvent = ^TEvent;
  TEvent = record
    What: Word;
    case Word of
      evNothing: ();
      evMouse: (
        Buttons: Byte;
        Double: Boolean;
        Where: TPoint);
      evKeyDown: (
        case Integer of
          0: (KeyCode: System.Word
             {$ifdef __OS2__} ;ShiftState: Byte {$endif});
          1: (CharCode: Char;
              ScanCode: Byte));
      evMessage: (
        Command: Word;
        case Word of
          0: (InfoPtr: Pointer);
          1: (InfoLong: Longint);
          2: (InfoWord: Word);
          3: (InfoInt: Integer);
          4: (InfoByte: Byte);
          5: (InfoChar: Char));
  end;

  TShiftStateHandler = function(var ShiftState: Byte): Boolean;
  TCtrlBreakAction = procedure;
{$ifdef __OS2__}
const

{ Initialized variables }

  ButtonCount: Byte = 0;
  MouseEvents: Boolean = False;
  MouseReverse: Boolean = False;
  DoubleDelay: Word = 8;
  RepeatDelay: Word = 8;
  GetShiftStateHandler: TShiftStateHandler = nil;
  CtrlBreakAction: TCtrlBreakAction = nil;
  KeyDownMask: Word = evKeyDown;
{$endif}
var
{$ifdef __OS2__}
  MouseButtons: Byte;
  MouseWhere: TPoint;
{$else}
  MouseEvents: Boolean;
  MouseReverse: Boolean;
  DoubleDelay: Word;
  RepeatDelay: Word;
  MouseIntFlag: Byte;
  MouseButtons: System.Word;
  MouseWhere: record X, Y: System.Word end;
{$endif}

{ Event manager routines }

procedure InitEvents;
procedure DoneEvents;
procedure GetMouseEvent(var Event: TEvent);
procedure GetKeyEvent(var Event: TEvent);
function GetShiftState: Byte;
{$ifdef __OS2__}
procedure ShowMouse;
procedure HideMouse;
procedure UpdateMouseWhere;
{$else}
procedure GetCursorShape (var cStart: Word; var cEnd: Word);
procedure SetCursorShape (cStart: Word; cEnd: Word);
{$endif}
{ ******** SCREEN MANAGER ******** }

const

{ Screen modes }

  smBW80    = $0002;
  smCO80    = $0003;
  smMono    = $0007;
  smFont8x8 = $0100;

const

{ Initialized variables }

  StartupMode: Word = $FFFF;
  CheckSnow: Boolean = False;   { not used }

var

{ Uninitialized variables }

  ScreenMode: Word;
  ScreenWidth: Byte;
  ScreenHeight: Byte;
  HiResScreen: Boolean;
  ScreenBuffer: Pointer;
  CursorLines: System.Word;

{ Screen manager routines }

procedure InitVideo;
procedure DoneVideo;
procedure SetVideoMode(Mode: Word);
procedure ClearScreen;

{ Keyboard }

{$ifdef __OS2__}  procedure InitKeyboard; {$endif}

{ Initialized variables }

const
  CtrlBreakHit: Boolean = False;
  SaveCtrlBreak: Boolean = False;       { not used }
  SysErrActive: Boolean = False;
  FailSysErrors: Boolean = False;       { not used }

{ System error handler routines }

procedure InitSysError;
procedure DoneSysError;

{ ******** UTILITY ROUTINES ******** }

{ Keyboard support routines }

function GetAltChar(KeyCode: Word): Char;
function GetAltCode(Ch: Char): Word;
function GetCtrlChar(KeyCode: Word): Char;
function GetCtrlCode(Ch: Char): Word;
function CtrlToArrow(KeyCode: Word): Word;

{ String routines }

procedure FormatStr(var Result: String; const Format: String; var Params);
procedure PrintStr(const S: String);

{ Buffer move routines }

procedure MoveBuf(var Dest; var Source; Attr: Byte; Count: Word);
procedure MoveChar(var Dest; C: Char; Attr: Byte; Count: Word);
procedure MoveCStr(var Dest; const Str: String; Attrs: Word);
procedure MoveStr(var Dest; const Str: String; Attr: Byte);
function CStrLen(const S: String): Integer;

implementation

uses Dos, {$ifdef __OS2__} Os2Types,{$endif} DosCall {$ifndef __OS2__} ,Mouse {$endif};

{ ******** EVENT MANAGER ******** }

{$ifdef __OS2__}
var

{ Event manager variables }

  LastButtons: Byte;
  DownButtons: Byte;
  LastDouble: Boolean;
  DownWhere: TPoint;
  DownTicks: Word;
  AutoTicks: Word;
  AutoDelay: Word;

  hMou: System.Word;
  ProtectArea: NoPtrRect;
  MouseMSec: Longint;

  VioMode: VioModeInfo;
  StartupVioMode: VioModeInfo;
  StartupCursor: VioCursorInfo;

{ Detects mouse driver, moves mouse pointer to the top left corner }

procedure DetectMouse;
var
  MouLoc: PtrLoc;
  Buttons: System.Word;
begin
  ButtonCount := 0;
  if Mou16Open(nil, hMou) = 0 then
  begin
    Mou16GetNumButtons(Buttons,hMou);
    ButtonCount := Buttons;
    MouLoc.Row := 0;
    MouLoc.Col := 0;
    Mou16SetPtrPos(MouLoc, hMou);
  end;
end;

{ Shows mouse pointer }

procedure ShowMouse;
var
  Status: System.Word;
begin
  if ButtonCount <> 0 then Mou16DrawPtr(hMou);
end;

{ Hides mouse pointer }

procedure HideMouse;
begin
  if ButtonCount <> 0 then Mou16RemovePtr(ProtectArea, hMou);
end;

{ Initializes Turbo Vision's event manager by setting event mask and    }
{ showing the mouse. Called automatically by TApplication.Init.         }
procedure InitEvents;
var
  MouLoc: PtrLoc;
  EventMask: System.Word;
begin
  if ButtonCount <> 0 then
  begin                                  { Mouse is available    }
    DownButtons := 0;
    LastDouble  := False;
    Mou16GetPtrPos(MouLoc, hMou);
    MouseWhere.X := MouLoc.Col;
    MouseWhere.Y := MouLoc.Row;
    Mou16DrawPtr(hMou);
    LastButtons := 0;                    { Assume that no button is pressed }
    EventMask := $FFFF;
    Mou16SetEventMask(EventMask, hMou);    { Select all events }
    MouseEvents := True;
  end;
end;

{ Terminates Turbo Vision's event manager and hides the mouse. Called }
{ automa     tically by TApplication.Done.                                    }

procedure DoneEvents;
var
  EventMask: System.Word;
begin
  if ButtonCount <> 0 then
  begin
    HideMouse;
    EventMask := $FFFF {0};   {Msh&San}
    Mou16SetEventMask(EventMask, hMou);   { Mask all events }
    MouseEvents := False;
  end;
end;

{ Checks whether a mouse event is available by polling the mouse event  }
{ queue maintained by OS/2. If a mouse event has occurred, Event.What   }
{ is set to evMouseDown, evMouseUp,evMouseMove, or evMouseAuto;         }
{ Event.Buttons is set to mbLeftButton or mbRightButton;                }
{ Event.Double is set to True or False;
{ Event.Where is set to the mouse position in global coordinates.       }
{ If no mouse events are available, Event.What is set to evNothing.     }
{ GetMouseEvent is called by TProgram.GetEvent.                         }

procedure GetMouseEvent(var Event: TEvent);
var
  MouEvent: MouEventInfo;
  MouQInfo: MouQueInfo;
  CurTicks: Word;
  B1,B2: Byte;
const
  WaitFlag: System.Word = mou_NoWait;

procedure StoreEvent(MouWhat: Word);
begin
  LastButtons := MouseButtons;
  MouseWhere.X := MouEvent.Col;
  MouseWhere.Y := MouEvent.Row;
  with Event do
  begin
    What := MouWhat;
    Buttons := MouseButtons;
    Double  := LastDouble;
    Where.X := MouEvent.Col;
    Where.Y := MouEvent.Row;
  end;
end;

{ GetMouseEvent body }

begin
  if not MouseEvents then Event.What := evNothing
else
  begin
    Mou16GetNumQueEl(MouQInfo, hMou);
    if MouQinfo.cEvents = 0 then
    begin
      MouseButtons := LastButtons;
      DosQuerySysInfo(qsv_Ms_Count, qsv_Ms_Count, MouEvent.Time, SizeOf(MouEvent.Time));
      MouEvent.Col  := MouseWhere.X;
      MouEvent.Row  := MouseWhere.Y;
    end
   else
    begin
      Mou16ReadEventQue(MouEvent, WaitFlag, hMou);
      if MouseReverse then
      begin
        B1 := mbRightButton;
        B2 := mbLeftButton;
      end
     else
      begin
        B1 := mbLeftButton;
        B2 := mbRightButton;
      end;
      if (MouEvent.fs and (mouse_Motion_With_Bn1_Down or mouse_Bn1_Down)) <> 0
        then MouseButtons := B1 else MouseButtons := 0;
      if (MouEvent.fs and (mouse_Motion_With_Bn2_Down or mouse_Bn2_Down)) <> 0
        then MouseButtons := MouseButtons or B2;
    end;
    { ms -> ticks: 1 DOS timer tick = 55ms }
    CurTicks := MouEvent.Time div 55;
    MouseMSec := MouEvent.Time;
    { Process mouse event }
    if (LastButtons <> 0) and (MouseButtons = 0) then StoreEvent(evMouseUp) { button is released }
   else
    if  LastButtons = MouseButtons then
    begin
      if (MouEvent.Row <> MouseWhere.Y) or (MouEvent.Col <> MouseWhere.X) then StoreEvent(evMouseMove)
     else
      if (MouseButtons <> 0) and ((CurTicks - AutoTicks) >= AutoDelay) then
      begin
        AutoTicks := CurTicks;
        AutoDelay := 1;
        StoreEvent(evMouseAuto);
      end
     else StoreEvent(evNothing);
    end
   else               { CurButton <> 0, LastButton = 0 }
    begin
      LastDouble := False;
      if (MouseButtons = DownButtons) and (MouEvent.Row = DownWhere.Y) and (MouEvent.Col = DownWhere.X)
      and ((CurTicks - DownTicks) < DoubleDelay) then LastDouble := True;
      DownButtons := MouseButtons;
      DownWhere.Y := MouEvent.Row;
      DownWhere.X := MouEvent.Col;
      DownTicks   := CurTicks;
      AutoTicks   := CurTicks;
      AutoDelay   := RepeatDelay;
      StoreEvent(evMouseDown);
    end;
  end;
end;

{ Initializes keyboard. Setups keyboard BINARY mode that allows Ctrl-C  }
{ to be handled in a normal way as an ordinal keystroke.                }

procedure InitKeyboard;
var
  Key: KbdInfo;
begin
  Key.cb := SizeOf(KbdInfo);
  Kbd16GetStatus(Key,0);        { Disable ASCII & Enable raw (binary) mode}
  Key.fsMask := (Key.fsMask and (not keyboard_Ascii_Mode)) or keyboard_Binary_Mode;
  Kbd16SetStatus(Key,0);
end;

{ UpdateMouseWhere is called from Views.WriteView procedure just before }
{ output to screen is to occur. It's too slow to query mouse pointer    }
{ location each time this procedure is called. That's why appoximate    }
{ approach is used instead. Mouse pointer location is queried only      }
{ after some defined time interval (5ms) elapsed since pointer location }
{ was known exactly. Surely, this doesn't fix the mouse "dropping"      }
{ problem completely, however experiments show rather good results.     }

procedure UpdateMouseWhere;
var
  MouLoc: PtrLoc;
  MSec: Longint;
begin
  DosQuerySysInfo(qsv_Ms_Count, qsv_Ms_Count, MSec, SizeOf(MSec));
  if MSec - MouseMSec >= 5 then
  begin
    MouseMSec := MSec;
    Mou16GetPtrPos(MouLoc, hMou);
    MouseWhere.X := MouLoc.Col;
    MouseWhere.Y := MouLoc.Row;
  end;
end;

{ Checks whether a keyboard event is available. If a key has been       }
{ pressed, Event.What is set to evKeyDown and Event.KeyCode is set to   }
{ the scan code of the key. Otherwise, Event.What is set to evNothing.  }
{ GetKeyEvent is called by TProgram.GetEvent.                           }

procedure GetKeyEvent(var Event: TEvent);
var
  Key: KbdKeyInfo;
  I: Integer;
{ Keyboard scan codes }
const
  scSpace    = $39;  scIns      = $52;  scDel      = $53;
  scBack     = $0E;  scUp       = $48;  scDown     = $50;
  scLeft     = $4B;  scRight    = $4D;  scHome     = $47;
  scEnd      = $4F;  scPgUp     = $49;  scPgDn     = $51;
  scCtrlIns  = $92;  scCtrlDel  = $93;  scCtrlUp   = $8D;
  scCtrlDown = $91;

const
  kbShift    = kbLeftShift + kbRightShift;

type
  KeyTransEntry = record
    Scan:  Byte;
    Shift: Byte;
    Code:  Word;
  end;

const
  KeyTranslateTable : array [1..15] of KeyTransEntry =
    (( Scan: scSpace   ; Shift: kbAltShift   ; Code: kbAltSpace ),   { Alt-Space     }
     ( Scan: scIns     ; Shift: kbCtrlShift  ; Code: kbCtrlIns  ),   { Ctrl-Ins      }
     ( Scan: scCtrlIns ; Shift: kbCtrlShift  ; Code: kbCtrlIns  ),   { Ctrl-Ins      }
     ( Scan: scIns     ; Shift: kbLeftShift  ; Code: kbShiftIns ),   { Shift-Ins     }
     ( Scan: scIns     ; Shift: kbRightShift ; Code: kbShiftIns ),   { Shift-Ins     }
     ( Scan: scIns     ; Shift: kbShift      ; Code: kbShiftIns ),   { Shift-Ins     }
     ( Scan: scDel     ; Shift: kbCtrlShift  ; Code: kbCtrlDel  ),   { Ctrl-Del      }
     ( Scan: scCtrlDel ; Shift: kbCtrlShift  ; Code: kbCtrlDel  ),   { Ctrl-Del      }
     ( Scan: scDel     ; Shift: kbLeftShift  ; Code: kbShiftDel ),   { Shift-Del     }
     ( Scan: scDel     ; Shift: kbRightShift ; Code: kbShiftDel ),   { Shift-Del     }
     ( Scan: scDel     ; Shift: kbShift      ; Code: kbShiftDel ),   { Shift-Del     }
     ( Scan: scBack    ; Shift: kbAltShift+kbLeftShift ; Code: kbAltShiftBack), { Alt-Shift-Backspace }
     ( Scan: scBack    ; Shift: kbAltShift+kbRightShift; Code: kbAltShiftBack), { Alt-Shift-Backspace }
     ( Scan: scBack    ; Shift: kbAltShift+kbShift     ; Code: kbAltShiftBack), { Alt-Shift-Backspace }
     ( Scan: scBack    ; Shift: kbAltShift   ; Code: kbAltBack  ));  { Alt-Backspace }
begin
  Kbd16CharIn(Key, io_NoWait, 0);
  if (Key.fbStatus and kbdtrf_Final_Char_In) = 0 then Event.What := evNothing
 else
  begin
    with Event do                       { Key is ready }
    begin
      What := KeyDownMask;
      CharCode := Key.chChar;
      ScanCode := Key.chScan;
      ShiftState := Key.fsState;
      for I := Low(KeyTranslateTable) to High(KeyTranslateTable) do
        with KeyTranslateTable[I] do
        begin
          if (Scan = Key.chScan ) and ((Shift and Key.fsState) = Shift) then
          begin
            KeyCode := Code;
            Break;
          end;
        end;
      if (CharCode = #$E0) and
--         (ScanCode = ScRight) or (ScanCode = ScLeft) or (ScanCode = ScDown) or (ScanCode = ScUp)
        (ScanCode in
         [scUp,scDown,scLeft,scRight,scIns,scDel,scHome,scEnd,scPgUp,scPgDn,
          Hi(kbCtrlHome), Hi(kbCtrlEnd)  , Hi(kbCtrlPgUp), Hi(kbCtrlPgDn),
          Hi(kbCtrlLeft), Hi(kbCtrlRight),    scCtrlUp,       scCtrlDown])
        then CharCode := #00; { Grey Keys   }
      if KeyCode = $E00D then KeyCode := kbEnter;     { Grey Enter  }
    end;
  end;
end;

{ Returns a byte containing the current Shift key state, as reported by }
{ OS/2. The return value contains a combination of the kbXXXX constants }
{ for shift states.                                                     }

function GetShiftState: Byte;
var
  Key: KbdInfo;
  ShiftState: Byte;
  Handled: Boolean;
begin
  if @GetShiftStateHandler <> nil then Handled := GetShiftStateHandler(ShiftState)
 else Handled := False;
  if not Handled then
  begin
    Key.cb := SizeOf(KbdInfo);
    Kbd16GetStatus(Key, 0);
    ShiftState := Key.fsState;
  end;
  GetShiftState := ShiftState;
end;

{ ******** SCREEN MANAGER ******** }

{ Returns current CRT mode }

function GetCrtMode: Word;
var
  Mode: Word;
begin
  VioMode.cb := SizeOf(VioMode);
  Vio16GetMode(VioMode, 0);
  with VioMode do
  begin
    if (fbType and vgmt_DisableBurst) = 0
      then Mode := smCO80 else Mode := smBW80;
    if Color = 0 then Mode := smMono;
    if Row > 25 then Inc(Mode, smFont8x8);
    GetCrtMode := Mode;
    if ((VioMode.fbType and vgmt_Graphics) <> 0) or
      (Col <> 80) then GetCrtMode := 0;
  end;
end;

{ Setups CRT mode }

procedure SetCrtMode(Mode: Word);
var
  BiosMode: Byte;
  CurData: VioCursorInfo;
  VideoConfig: VioConfigInfo;
begin
  BiosMode := Lo(Mode);
  VideoConfig.cb := SizeOf(VideoConfig);
  Vio16GetConfig(0, VideoConfig, 0);
  with VioMode do
  begin
    cb := SizeOf(VioMode);
    fbType := vgmt_Other;
    Color := colors_16;         { Color }
    Row := 25;                  { 80x25 }
    Col := 80;
    VRes := 400;
    HRes := 720;
    if (Mode and smFont8x8) <> 0 then
    case VideoConfig.Adapter of { 80x43 }
      display_Monochrome..display_CGA: ;
      display_EGA:
        begin
          Row := 43; VRes := 350; HRes := 640;
        end;
      else                      { 80x50 }
        begin
          Row := 50; VRes := 400; HRes := 720;
        end;
    end;
    case BiosMode of            { Black and white }
      smBW80: fbType := vgmt_Other + vgmt_DisableBurst;
      smMono:
        begin                   { Monochrome }
          HRes := 720; VRes := 350; Color := 0; fbType := 0;
        end;
    end;
  end;
  Vio16SetMode(VioMode, 0);
end;
{$else}
const

{ Event manager constants }

  EventQSize = 16;

var

{ Event manager variables }

  LastButtons: Byte;
  DownButtons: Byte;
  LastDouble: Boolean;
  LastWhere: TPoint;
  DownWhere: TPoint;
  DownTicks: Word;
  AutoTicks: Word;
  AutoDelay: Word;
  EventCount: Word;
  EventQHead: Pointer;
  EventQTail: Pointer;
  EventQueue: array[0..EventQSize - 1] of TEvent;
  EventQLast: record end;

  hMou: System.Word;
  MouseMSec: Longint;

  VioMode: VioModeInfo;
  StartupVioMode: VioModeInfo;
  StartupCursor: VioCursorInfo;

procedure GetCursorShape (var cStart: Word; var cEnd: Word); assembler;
asm
        mov     ah,03
        xor     ebx,ebx
        int     10H
        movzx   eax,ch
        mov     edx,cStart
        mov     dword ptr[edx],eax
        movzx   eax,cl
        mov     edx,cEnd
        mov     dword ptr[edx],eax
end;

procedure SetCursorShape (cStart, cEnd: Word); assembler;
asm
       mov      ah,01
       mov      ebx,cStart
       test     ebx,ebx
       jne      @@1
       mov      bl,20H
@@1:   mov      ch,bl
       mov      ebx,cEnd
       test     ebx,ebx
       jne      @@2
       mov      bl,20H
@@2:   mov      cl,bl
       int      10H
end;

{ Initializes Turbo Vision's event manager by setting event mask and    }
{ showing the mouse. Called automatically by TApplication.Init.         }

procedure MouseInt (Mask, Btns, whereX, whereY, movX, movY: System.Word);
begin
      MouseButtons := Btns;
      MouseWhere.X := whereX;
      MouseWhere.Y := whereY;
      if ((Mask and $1E) <> 0) and (EventCount <> EventQSize)
      then begin
             with PEvent(EventQTail)^ do
             begin
                 What := MemW[_zero + $46c];
                 Buttons := WordRec(Btns).Lo;
                 Where.X := whereX;
                 Where.Y := whereY;
             end;
             inc (EventCount);
             EventQTail := EventQTail + SizeOf(TEvent);
             if EventQTail = @EventQLast then EventQTail := @EventQueue[0];
          end;
     MouseIntFlag := 1;
end;

procedure InitEvents;
var
  EventMask: System.Word;
begin
  InitMouse;
  MouseIntFlag := 0;
  if ButtonCount <> 0 then
  begin                                  { Mouse is available    }
    DownButtons := 0;
    LastDouble  := False;
    EventCount := 0;
    EventQHead := @EventQueue[0];
    EventQTail := EventQHead;
    GetMouseInfo (MouseButtons, MouseWhere.X, MouseWhere.Y);
    MouseButtons := 0;
    LastButtons := {WordRec(MouseButtons).Lo}0;
    LastWhere.X := MouseWhere.X;
    LastWhere.Y := MouseWhere.Y;
    EventMask := $FFFF;
    MouseEvents := True;
    SetMouseHandler ($FFFF, MouseInt);
  end;
end;

{ Terminates Turbo Vision's event manager and hides the mouse. Called }
{ automatically by TApplication.Done.                                 }

procedure DoneEvents;
begin
  if (ButtonCount <> 0) and MouseEvents then
  begin
    DoneMouse;
    MouseEvents := False;
  end;
end;
{ Get mouse state }
{ Out   BL = Button mask }
{       CX = X coordinate }
{       DX = Y coordinate }
{       DI = Timer ticks }

procedure GetMouseState; code;
asm
        cli
        cmp     EventCount,0
        jne     @@1
        mov     bl,MouseButtons.Byte
        xor     ecx,ecx
        mov     edx,ecx
        mov     cx,word ptr[MouseWhere.X]
        mov     dx,word ptr[MouseWhere.Y]
        mov     eax,$46c   {Ticks}
        add     eax,_zero
        mov     di,word ptr[eax]
        jmp     @@3
@@1:    mov     esi,EventQHead
        cld
        lodsd
        xchg    eax,edi
        lodsw
        xchg    eax,ebx
        and     ebx,$FF
        lodsd
        xchg    eax,ecx
        lodsd
        xchg    eax,edx
        cmp     esi,OFFSET EventQLast
        jne     @@2
        mov     esi,OFFSET EventQueue
@@2:    mov     EventQHead,esi
        dec     EventCount
@@3:    sti
        cmp     MouseReverse,0
        je      @@4
        mov     bh,bl
        and     bh,3
        je      @@4
        cmp     bh,3
        je      @@4
        xor     bl,3
@@4:    ret
end;

procedure GetMouseEvent(var Event: TEvent); assembler;
asm
        cmp     MouseEvents,0
        je      @@2
        call    GetMouseState
        mov     bh,LastDouble
        mov     al,LastButtons
        cmp     al,bl
        je      @@1
        or      al,al
        je      @@3
        or      bl,bl
        je      @@5
        mov     bl,al
@@1:    cmp     ecx,LastWhere.X
        jne     @@6
        cmp     edx,LastWhere.Y
        jne     @@6
        or      bl,bl
        je      @@2
        mov     eax,edi
        sub     eax,AutoTicks
        cmp     eax,AutoDelay
        jae     @@7
@@2:    xor     eax,eax
        mov     ebx,eax
        mov     ecx,eax
        mov     edx,eax
        jmp     @@9
@@3:    mov     bh,0
        cmp     bl,DownButtons
        jne     @@4
        cmp     ecx,DownWhere.X
        jne     @@4
        cmp     edx,DownWhere.Y
        jne     @@4
        mov     eax,edi
        sub     eax,DownTicks
        cmp     eax,DoubleDelay
        jae     @@4
        mov     bh,1
@@4:    mov     DownButtons,bl
        mov     DownWhere.X,ecx
        mov     DownWhere.Y,edx
        mov     DownTicks,edi
        mov     AutoTicks,edi
        mov     eax,RepeatDelay
        mov     AutoDelay,eax
        mov     eax,evMouseDown
        jmp     @@8
@@5:    mov     eax,evMouseUp
        jmp     @@8
@@6:    mov     eax,evMouseMove
        jmp     @@8
@@7:    mov     AutoTicks,edi
        mov     AutoDelay,1
        mov     eax,evMouseAuto
@@8:    mov     LastButtons,bl
        mov     LastDouble,bh
        mov     LastWhere.X,ecx
        mov     LastWhere.Y,edx
@@9:    mov     edi,Event
        cld
        stosd
        xchg    eax,ebx
        stosw
        xchg    eax,ecx
        stosd
        xchg    eax,edx
        stosd
end;
{ Checks whether a keyboard event is available. If a key has been       }
{ pressed, Event.What is set to evKeyDown and Event.KeyCode is set to   }
{ the scan code of the key. Otherwise, Event.What is set to evNothing.  }
{ GetKeyEvent is called by TProgram.GetEvent.                           }

procedure GetKeyEvent(var Event: TEvent); assembler;
asm
        mov     ah,1
        int     16H
        mov     eax,0
        mov     ebx,eax
        je      @@1
        mov     ah,0
        int     16H
        xchg    eax,ebx
        mov     eax,evKeyDown
        cmp     bx,14624
        jne     @@1
        mov     bx,kbAltSpace
@@1:    mov     ecx,Event
        mov     [ecx].TEvent.what,eax
        mov     [ecx].TEvent.keyCode,bx
end;


{ Returns a byte containing the current Shift key state, as reported by }
{ OS/2. The return value contains a combination of the kbXXXX constants }
{ for shift states.                                                     }

function GetShiftState: Byte;
begin
   GetShiftState := Mem[_zero+$417]
end;

{ ******** SCREEN MANAGER ******** }

{ Returns current CRT mode }

function GetCrtMode: Word;
{begin
    GetLastMode;
    GetCrtMode := LastMode}
var
  Mode: Word;
begin
  VioMode.cb := SizeOf(VioMode);
  VioMode.col := MemW [_zero+$44a];
  VioMode.row  := MemW [_zero+$44c] div (VioMode.col * 2);
  if VioMode.Row >= 50 then VioMode.Row := 50
  else if VioMode.Row >= 43 then VioMode.Row := 43
  else VioMode.Row := 25;
  Mode := Mem  [_zero+$449];
  if VioMode.Row > 25 then Inc(Mode, smFont8x8);
  GetCrtMode := Mode;
end;

{ Setups CRT mode }

procedure SetCrtMode(Mode: Word);
begin
    TextMode (Mode)
end;
{$endif}
{ Fix CRT mode if required }

function FixCrtMode(Mode: Word): Word;
begin
  case Lo(Mode) of
    smMono,smCO80,smBW80: FixCrtMode := Mode
    else                  FixCrtMode := smCO80;
  end;
end;

{ Sets CRT data areas and mouse range }
{$ifdef __OS2__}
procedure SetCrtData;
var
  VideoConfig: VioConfigInfo;
  BufSize: System.Word;
  CurData: VioCursorInfo;
begin
  ScreenMode := GetCrtMode;
  ScreenHeight := VioMode.Row;
  ScreenWidth := VioMode.Col;
  ProtectArea.Row := 0;
  ProtectArea.Col := 0;
  ProtectArea.cRow := ScreenHeight - 1;
  ProtectArea.cCol := ScreenWidth - 1;
  ShowMouse;
  HiResScreen  := False;
  VideoConfig.cb := SizeOf(VideoConfig);
  if (Vio16GetConfig(0, VideoConfig, 0) = 0) then
    if VideoConfig.Adapter >= display_EGA then HiResScreen := True;
  Vio16GetBuf(ScreenBuffer,BufSize,0);
  SelToFlat(ScreenBuffer);  {Msh}
  Vio16GetCurType(CurData, 0);                    { Get cursor lines }
  WordRec(CursorLines).Hi := CurData.yStart;
  WordRec(CursorLines).Lo := CurData.cEnd;
  CurData.attr := $FFFF;
  Vio16SetCurType(CurData,0);                     { Hide cursor }
end;
{$else}
{ Sets CRT data areas and mouse range }

procedure SetCrtData;
var
  BufSize: System.Word;
  CurData: VioCursorInfo;
begin
  ScreenMode := GetCrtMode;
  ScreenHeight := VioMode.Row;
  ScreenWidth := VioMode.Col;
  ShowMouse;
  HiResScreen  := False;
  HiResScreen := False;
  asm
     mov    ah,12H
     mov    bl,10H
     int    10H
     cmp    bl,4
     jge    @@1
     mov    HiResScreen,1
  @@1:
  end;
  GetMem (ScreenBuffer, VioMode.Row * VioMode.Col * 2);
  GetCursorShape(CurData.yStart, CurData.cEnd); { Get cursor lines }
  WordRec(CursorLines).Hi := CurData.yStart;
  WordRec(CursorLines).Lo := CurData.cEnd;
  SetCursorShape ($20, $20);                    { Hide cursor }
end;
{$endif}
{ Detects video modes }

procedure DetectVideo;
begin
  ScreenMode := FixCrtMode(GetCrtMode);
  StartupVioMode := VioMode;
end;

{ Initializes Turbo Vision's video manager. Saves the current screen    }
{ mode in StartupMode, and switches the screen to the mode indicated by }
{ ScreenMode. The ScreenWidth, ScreenHeight, HiResScreen, ScreenBuffer, }
{ and CursorLines variables are updated accordingly.InitVideo is called }
{ automatically by TApplication.Init.                                   }

procedure InitVideo;
begin
{$ifdef __OS2__}
  Vio16GetCurType(StartupCursor, 0);
{$else }
  GetCursorShape(StartupCursor.yStart, StartupCursor.cEnd);
{$endif}
  StartupMode := GetCrtMode;
  if StartupMode <> ScreenMode then SetCrtMode(ScreenMode);
  SetCrtData;
{$ifndef __OS2__}
  DirectVideo := true
{$endif}
end;

{ Terminates Turbo Vision's video manager by restoring the initial      }
{ screen mode, clearing the screen, and restoring the cursor. Called    }
{ automatically by TApplication.Done.                                   }

procedure DoneVideo;
begin
{$ifdef __OS2__}
  if (StartupMode <> $FFFF) and (StartupMode <> ScreenMode) then
    Vio16SetMode(StartupVioMode, 0);
  ClearScreen;
  Vio16SetCurType(StartupCursor, 0);
{$else }
  if (StartupMode <> $FFFF) and (StartupMode <> ScreenMode) then
      TextMode (StartupVioMode.fbtype);
  ClearScreen;
  SetCursorShape(StartupCursor.yStart, StartupCursor.cEnd);
{$endif}
end;

{ Sets the video mode. Mode is one of the constants smCO80, smBW80, or smMono, }
{ optionally with smFont8x8 added to select 43- or 50-line mode on an EGA or   }
{ VGA. SetVideoMode initializes the same variables as InitVideo (except for    }
{ the StartupMode variable, which isn't affected).                             }

procedure SetVideoMode(Mode: Word);
begin
  SetCrtMode(FixCrtMode(Mode));
  SetCrtData;
end;

{ Clears the screen, moves cursor to the top left corner }

procedure ClearScreen;
{$ifdef __OS2__}
const
  Cell: System.Word = $0720;    { Space character, white on black }
begin
  Vio16ScrollUp(0, 0, 65535, 65535, 65535, Cell, 0);
  Vio16SetCurPos(0, 0, 0);
end;
{$else}
begin
   ClrScr
end;
{$endif}
{$ifdef __OS2__}
{ ********************* SYSTEM ERROR HANDLER ************************** }

{ No critical error handler is implemented for OS/2.                    }
{ Default OS/2 system error handler traps all critical errors.          }
{ Unlike DOS critical error handler it doesn't corrupt user screen.     }
{ That's why it is not so interesting to write one more of your own.    }

{ Ctrl-Break signal handler. Sets CtrlBreakHit to True whenever         }
{ Ctrl-Break is hit. Note: when keyboard is switched to the raw         }
{ (binary mode) mode xcpt_Signal_Intr signal (Ctrl-C) is not reported.  }

function CtrlBreakHandler(Report:       PExceptionReportRecord;
                          Registration: PExceptionRegistrationRecord;
                          Context:      PContextRecord;
                          P:            Pointer): ULong; { cdecl; }
begin
  CtrlBreakHandler := xcpt_Continue_Search;
  if (Report^.ExceptionNum = xcpt_Signal) then
    case Report^.ExceptionInfo[0] of
      xcpt_Signal_Intr,xcpt_Signal_Break:
        begin
          CtrlBreakHit := True;
          if Assigned(CtrlBreakAction) then CtrlBreakAction;
          CtrlBreakHandler := xcpt_Continue_Execution;
        end;
    end;
end;

{ Initializes Turbo Vision's system error handler. Called automatically }
{ by TApplication.Init. Since no error handler is available,InitSysError}
{ sets SysErrActive to True and does nothing.                           }
{$endif}
procedure InitSysError;
begin
  SysErrActive := True;
end;

{ Terminates Turbo Vision's system error handler. Called automatically  }
{ by TApplication.Done. Since no error handler is available,DoneSysError}
{ sets SysErrActive to False and does nothing.                          }

procedure DoneSysError;
begin
  SysErrActive := False;
end;

{ ******** UTILITY ROUTINES ******** }

{ Keyboard support routines }

const

  AltCodes1: array[$10..$32] of Char =
    'QWERTYUIOP'#0#0#0#0'ASDFGHJKL'#0#0#0#0#0'ZXCVBNM';

  AltCodes2: array[$78..$83] of Char =
    '1234567890-=';

function GetAltChar(KeyCode: Word): Char;
begin
  GetAltChar := #0;
  if Lo(KeyCode) = 0 then
    case Hi(KeyCode) of
      $02: GetAltChar := #240;
      $10..$32: GetAltChar := AltCodes1[Hi(KeyCode)];
      $78..$83: GetAltChar := AltCodes2[Hi(KeyCode)];
    end;
end;

function GetAltCode(Ch: Char): Word;
var
  I: Word;
begin
  GetAltCode := 0;
  if Ch = #0 then Exit;
  Ch := UpCase(Ch);
  if Ch = #240 then
  begin
    GetAltCode := $0200;
    Exit;
  end;
  for I := $10 to $32 do
    if AltCodes1[I] = Ch then
    begin
      GetAltCode := I shl 8;
      Exit;
    end;
  for I := $78 to $83 do
    if AltCodes2[I] = Ch then
    begin
      GetAltCode := I shl 8;
      Exit;
    end;
end;

function GetCtrlChar(KeyCode: Word): Char;
begin
  GetCtrlChar := #0;
  if (Lo(KeyCode) <> 0) and (Lo(KeyCode) <= Byte('Z') - Byte('A') + 1) then
    GetCtrlChar := Char(Lo(KeyCode) + Byte('A') - 1);
end;

function GetCtrlCode(Ch: Char): Word;
begin
  GetCtrlCode := GetAltCode(Ch) or (Byte(UpCase(Ch)) - Byte('A') + 1);
end;

function CtrlToArrow(KeyCode: Word): Word;
const
  NumCodes = 11;
  CtrlCodes: array[0..NumCodes-1] of Char = '^S^D^E^X^A^F^G^V^R^C^H';
  ArrowCodes: array[0..NumCodes-1] of Word =
    (kbLeft, kbRight, kbUp, kbDown, kbHome, kbEnd, kbDel, kbIns,
     kbPgUp, kbPgDn, kbBack);
var
  I: Integer;
begin
  CtrlToArrow := KeyCode;
  for I := 0 to NumCodes - 1 do
    if WordRec(KeyCode).Lo = Byte(CtrlCodes[I]) then
    begin
      CtrlToArrow := ArrowCodes[I];
      Exit;
    end;
end;

{ A generalized string formatting routine. Given a string in Format     }
{ that includes format specifiers and a list of parameters in Params,   }
{ FormatStr produces a formatted output string in Result.               }
{ Format specifiers are of the form %[-][nnn]X, where                   }
{   % indicates the beginning of a format specifier                     }
{  [-] is an optional minus sign (-) indicating the parameter is to be  }
{      left-justified (by default, parameters are right-justified)      }
{ [nnn] is an optional, decimal-number width specifier in the range     }
{      0..255 (0 indicates no width specified, and non-zero means to    }
{      display in a field of nnn characters)                            }
{   X  is a format character:                                           }
{   's' means the parameter is a pointer to a string.                   }
{   'd' means the parameter is a Longint to be displayed in decimal.    }
{   'c' means the low byte of the parameter is a character.             }
{   'x' means the parameter is a Longint to be displayed in hexadecimal.}
{   '#' sets the parameter index to nnn.                                }

procedure FormatStr(var Result: String; const Format: String; var Params);
  assembler; { $USES ebx,esi,edi} { $FRAME+}
var
  ParOfs: Longint;
  Buffer: array [1..12] of Byte;
const
  HexDigits: array [0..15] of Char = '0123456789ABCDEF';

{ Convert next parameter to string              }
{ EXPECTS:      al    = Conversion character    }
{ RETURNS:      esi   = Pointer to string       }
{               ecx   = String length           }

--procedure Convert; assembler; { $USES None} { $FRAME-}
asm
        jmp @Start

@@Convert:       mov     edx,eax
                mov     esi,Params
                lodsd
                mov     Params,esi
                xor     ecx,ecx
                lea     esi,Buffer[TYPE Buffer]
                and     dl,0DFh         { UpCase(ConversionChar) }
                cmp     dl,'C'
                je      @@@ConvertChar
                cmp     dl,'S'
                je      @@@ConvertStr
                cmp     dl,'D'
                je      @@@ConvertDec
                cmp     dl,'X'
                jne     @@@Done
{ ConvertHex }
              @@@1:
                mov     edx,eax
                and     edx,0Fh
                mov     dl,HexDigits.Byte[edx]
                dec     esi
                inc     ecx
                mov     [esi],dl
                shr     eax,4
                jnz     @@@1
                jmp     @@@Done
@@@ConvertDec:
                push    esi
                mov     ebx,eax
                mov     ecx,10
                test    eax,eax
                jns     @@@2
                neg     eax
              @@@2:
                xor     edx,edx
                dec     esi
                div     ecx
                add     dl,'0'
                mov     [esi],dl
                test    eax,eax
                jnz     @@@2
                pop     ecx
                sub     ecx,esi
                test    ebx,ebx
                jns     @@@Done
                mov     al,'-'
@@@ConvertChar:
                inc     ecx
                dec     esi
                mov     [esi],al
                jmp     @@@Done
@@@ConvertStr:
                test    eax,eax
                jz      @@@Done
                mov     esi,eax
                lodsb
                mov     cl,al
              @@@Done:
                ret 0
--end;

{ FormatStr body }

--asm
@Start:
                mov     eax,Params
                mov     ParOfs,eax
                xor     eax,eax
                mov     esi,Format
                mov     edi,dword ptr[Result]
                inc     edi
                cld
                lodsb
                mov     ecx,eax
              @@1:
                jecxz   @@9
                lodsb
                dec     ecx
                cmp     al,'%'
                je      @@3
              @@2:
                stosb
                jmp     @@1
              @@3:
                jecxz   @@9
                lodsb
                dec     ecx
                cmp     al,'%'
                je      @@2             { bh = Justify (0:right, 1:left) }
                mov     ebx,' '         { bl = Filler character          }
                xor     edx,edx         { edx = Field width (0:no width) }
                cmp     al,'0'
                jne     @@4
                mov     bl,al
              @@4:
                cmp     al,'-'
                jne     @@5
                inc     bh
                jecxz   @@9
                lodsb
                dec     ecx
              @@5:
                cmp     al,'0'
                jb      @@6
                cmp     al,'9'
                ja      @@6
                sub     al,'0'
                xchg    eax,edx
                mov     ah,10
                mul     ah
                add     al,dl
                xchg    eax,edx
                jecxz   @@9
                lodsb
                dec     ecx
                jmp     @@5
              @@6:
                cmp     al,'#'
                jne     @@10
                shl     edx,2
                add     edx,ParOfs
                mov     Params,edx
                jmp     @@1
              @@9:
                mov     eax,dword ptr[Result]
                mov     ecx,edi
                sub     ecx,eax
                dec     ecx
                mov     [eax],cl
                jmp     @@Done
              @@10:
                push    esi
                push    ecx
                push    edx
                push    ebx
--                Call    Convert
                Call    @@Convert
                pop     ebx
                pop     edx
                test    edx,edx
                jz      @@12
                sub     edx,ecx
                jae     @@12
                test    bh,bh
                jnz     @@11
                sub     esi,edx
              @@11:
                add     ecx,edx
                xor     edx,edx
              @@12:
                test    bh,bh
                jz      @@13
                rep     movsb           { Copy formated parm (left-justified)}
              @@13:
                xchg    ecx,edx
                mov     al,bl
                rep     stosb           { Fill unused space }
                xchg    ecx,edx
                rep     movsb           { Copy formated parm (right-justified)}
                pop     ecx
                pop     esi
                jmp     @@1
              @@Done:
end;

{ Prints the string on the screen }

procedure PrintStr(const S: String);
var
  WCount: ULong;
begin
    Writeln (S)
end;

{ Buffer move routines }

{ Moves text and video attributes into a buffer. Count bytes are moved  }
{ from Source into the low bytes of corresponding words in Dest. The    }
{ high bytes of the words in Dest are set to Attr, or remain unchanged  }
{ if Attr is zero.                                                      }

{ $USES esi,edi} { $FRAME-}

procedure MoveBuf(var Dest; var Source; Attr: Byte; Count: Word); assembler;
asm
                mov     ecx,Count
                jecxz   @@4
                mov     edi,Dest
                mov     esi,Source
                mov     ah,Attr
                cld
                test    ah,ah
                jz      @@3
              @@1:
                lodsb
                stosw
                loop    @@1
                jmp     @@4
              @@2:
                inc     edi
              @@3:
                movsb
                loop    @@2
              @@4:
end;

{ Moves characters into a buffer. The low bytes of the first Count      }
{ words of Dest are set to C, or remain unchanged if C = #0. The high   }
{ bytes of the words are set to Attr, or remain unchanged if Attr is    }
{ zero.                                                                 }

{ $USES edi} { $FRAME-}

procedure MoveChar(var Dest; C: Char; Attr: Byte; Count: Word); assembler;
asm
                mov     ecx,Count
                jecxz   @@4
                mov     edi,Dest
                mov     al,C
                mov     ah,Attr
                cld
                test    al,al
                jz      @@1
                test    ah,ah
                jz      @@3
                mov     edx,eax
                shl     eax,16
                mov     ax,dx
                shr     ecx,1
                rep     stosd
                adc     ecx,ecx
                rep     stosw
                jmp     @@4
              @@1:
                mov     al,ah
              @@2:
                inc     edi
              @@3:
                stosb
                loop    @@2
              @@4:
end;

{ Moves a two-colored string into a buffer. The characters in Str are   }
{ moved into the low bytes of corresponding words in Dest. The high     }
{ bytes of the words are set to Lo(Attr) or Hi(Attr). Tilde characters  }
{ (~) in the string toggle between the two attribute bytes passed in    }
{ the Attr word.                                                        }

{ $USES esi,edi} { $FRAME-}

procedure MoveCStr(var Dest; const Str: String; Attrs: Word); assembler;
asm
                xor     ecx,ecx
                mov     esi,Str
                cld
                lodsb
                mov     cl,al
                jecxz   @@3
                mov     edi,Dest
                mov     edx,Attrs
                mov     ah,dl
              @@1:
                lodsb
                cmp     al,'~'
                je      @@2
                stosw
                loop    @@1
                jmp     @@3
              @@2:
                xchg    ah,dh
                loop    @@1
              @@3:
end;

{ Moves a string into a buffer. The characters in Str are moved into    }
{ the low bytes of corresponding words in Dest. The high bytes of the   }
{ words are set to Attr, or remain unchanged if Attr is zero.           }

{ $USES esi,edi} { $FRAME-}

procedure MoveStr(var Dest; const Str: String; Attr: Byte); assembler;
asm
                xor     ecx,ecx
                mov     esi,Str
                cld
                lodsb
                mov     cl,al
                jecxz   @@4
                mov     edi,Dest
                mov     ah,Attr
                test    ah,ah
                jz      @@3
              @@1:
                lodsb
                stosw
                loop    @@1
                jmp     @@4
              @@2:
                inc     edi
              @@3:
                movsb
                loop    @@2
              @@4:
end;

{ Returns the length of string S, where S is a control string using     }
{ tilde characters ('~') to designate shortcut characters. The tildes   }
{ are excluded from the length of the string, as they will not appear   }
{ on the screen.                                                        }

function CStrLen(const S: String): Integer; assembler; { $USES edi} { $FRAME-}
asm
                xor     ecx,ecx
                mov     edi,S
                mov     cl,[edi]
                inc     edi
                mov     edx,ecx
                jecxz   @@2
                mov     al,'~'
                cld
              @@1:
                repne   scasb
                jne     @@2
                dec     edx
                test    esp,esp
                jmp     @@1
              @@2:
                mov     eax,edx
end;

{ Drivers unit initialization and shutdown }

var
  SaveExit: Pointer;
  Times: ULong;

procedure ExitDrivers;
begin
  DoneSysError;
  DoneEvents;
  {$ifdef __OS2__} Mou16Close(hMou); {$endif}
  ExitProc := SaveExit;
end;

begin
{$ifdef __OS2__}
  InitKeyboard;
  DetectMouse;
{$else}
  MouseEvents:= False;
  MouseReverse:= False;
  DoubleDelay:= 8;
  RepeatDelay:= 8;
{$endif}
  DetectVideo;
  SaveExit := ExitProc;
  ExitProc := @ExitDrivers;
{$ifdef __OS2__}   DosSetSignalExceptionFocus(1, Times); {$endif}
end.
