Unit Mouse;
Interface

uses Dos, Crt;

var ButtonCount: Word;

Procedure InitMouse;
Procedure ShowMouse;
Procedure HideMouse;
Procedure SetMousePos  (X, Y: Integer);
Procedure GetMouseInfo (var ButtonMask: Word; var X: Word; var Y: Word);
Procedure SetMouseHandler (Mask: Word;  Procedure Hnd (Mask, Buttons, X, Y, MovX, MovY: System.Word));
Procedure ClearMouseHandler;
Procedure DoneMouse;

implementation

var
    save_ss:     DWord;
    save_sp:     DWord;
    Stack:       Pointer;
    new_stack:   Pointer;
    regs:        registers;
    MouseHnd:    procedure (Mask, Buttons, X, Y, MovX, MovY: System.Word);
    Hnd:         record
                     Entry, Base: Longint
                 end
                 absolute MouseHnd;
    hnd_es,
    hnd_dx:      Word;

procedure ShowMouse; assembler;
asm
        cmp     ButtonCount,0
        je      @@1
        push    eax
        mov     eax,1
        int     33H
        pop     eax
@@1:
end;

{$system}

procedure mousehandler; code;
asm
    push     ds
    push     es
    pushad
    mov      ds,cs:%flat_ds
    mov      es,cs:%flat_ds
    mov      save_ss,ss
    mov      save_sp,esp
    mov      ss,cs:%flat_ds
    mov      esp,new_stack

    cmp      dword ptr[MouseHnd],0
    je       @@1

    push     regs.eax
    push     regs.ebx
    mov      eax,regs.ecx
    and      eax,$ffff
    shr      eax,3
    push     eax
    mov      eax,regs.edx
    and      eax,$ffff
    shr      eax,3
    push     eax
    push     regs.esi
    push     regs.edi
    cld
    mov      ebp,dword ptr[MouseHnd+4]
    call     dword ptr[MouseHnd]
@@1:
    mov      ss,save_ss
    mov      esp,save_sp
    popad
    pop      es
    pop      ds

    push    eax
    mov     ax, ds:[esi]
    mov     es:[edi].registers.ip, ax
    mov     ax, ds:[esi+2]
    mov     es:[edi].registers.cs, ax
    add     es:[edi].registers.sp, 4
    pop     eax
    iretd
end;

procedure InitMouse;
var r: registers;
begin
     GetMem (Stack,4096);
     asm
         mov eax,Stack
         add eax,4096
         mov new_stack,eax
     end;
     ButtonCount := 0;
     r.ax := $3533;
     r.sp := 0;
     r.ss := 0;
     asm push es;
     end;
     Intr ($21, r);
     asm pop  es;
     end;
     if (r.es or r.bx) <> 0
     then begin
            asm
               push eax
               xor eax,eax
               int 33H
               or  eax,eax
               je  @@1
               mov ButtonCount,bx
               mov hnd_es, cx
               mov hnd_dx, dx
               pop eax
            @@1:
            end
          end;
     Hnd.Entry := 0;
     Hnd.Base  := 0;
     if (ButtonCount <>0)
     then begin
             ShowMouse;
             SetMousePos (0,0);
             asm
                mov ax, $0303
                mov esi, offset mousehandler
                mov edi, offset regs
                push ds
                push cs
                pop  ds
                int  $31
                pop  ds
                mov  hnd_es,cx
                mov  hnd_dx,dx
             end;
          end;
end;


procedure HideMouse; assembler;
asm
        cmp     ButtonCount,0
        je      @@1
        push    eax
        mov     eax,2
        int     33H
        pop     eax
@@1:
end;

procedure SetMousePos (X, Y: Integer); assembler;
asm
        cmp     ButtonCount,0
        je      @@1
        mov     ecx,dword ptr [X]
        shl     ecx,3
        mov     edx,dword ptr [Y]
        shl     edx,3
        mov     eax,4
        int     33H
@@1:
end;

procedure GetMouseInfo (var ButtonMask: Word; var X: Word; var Y: Word); assembler;
asm
        cmp     ButtonCount,0
        je      @@1
        mov     eax,3
        int     $33
        mov     eax,ButtonMask
        mov     word ptr[eax],bx
        mov     eax,X
        shr     cx,3
        mov     word ptr[eax],cx
        mov     eax,Y
        shr     dx,3
        mov     word ptr[eax],dx
@@1:
end;

Procedure SetMouseHandler (Mask: Word; procedure Hnd(Mask, Buttons, X, Y, MovX, MovY: System.Word));
var r: registers;
begin
     MouseHnd := Hnd;
     asm
        mov ax,hnd_es
        mov r.es,ax
        mov ax,hnd_dx
        mov r.dx,ax
        mov ax,Mask
        mov r.cx, ax
        mov r.ax, $c
        mov r.sp, 0
        mov r.ss, 0
        mov ax, $300
        mov bx, $33
        xor ecx, ecx
        mov r.sp, 0
        mov r.ss, 0
        lea edi, r
        int $31
     end;
end;

procedure ClearMouseHandler;
begin
     Hnd.Entry := 0;
     Hnd.Base  := 0;
end;

Procedure DoneMouse;
begin
     HideMouse;
     asm
         mov    cx,hnd_es
         mov    dx,hnd_dx
         mov    ax,$0304
         int    $31
         mov    eax,0cH
         xor    ecx,ecx
         int    $33
     end;
     ButtonCount := 0;
     FreeMem (Stack,4096)
end;

begin
    ButtonCount := 0
end.
